module Absy where

-- Abstract syntax for a small imperative language

data Cmd = (:=) Var Expr
         | Block [Cmd]
         | Print String Expr
         | Read Var
         | While BExpr Cmd
         | If BExpr Cmd Cmd
         | Break
         | Throw String
         | Catch Cmd (String-> Cmd) 
     
type Var = String

data Expr = Num Int
          | Var Var
          | Plus Expr Expr
          | Minus Expr Expr
          | Times Expr Expr
          | Div Expr Expr
          | Mod Expr Expr

data BExpr = Eq Expr Expr
           | Less Expr Expr
           | Not BExpr
           | And BExpr BExpr
           | Or BExpr BExpr
           | BTrue       
